#ifndef TRIANGLES_H
#define TRIANGLES_H

#include <allegro.h>
#include <math.h>
#include "alleggl.h"

typedef struct TRIANGLECOLOR
{
	float red, green, blue, alpha;
} TRIANGLECOLOR;

typedef struct TRIANGLEINFO
{
	double x[3], y[3], z[3];
	double n[3];
	struct TRIANGLECOLOR *color;	

	struct TRIANGLEINFO *nexttriangle;
} TRIANGLEINFO;

extern int					model_detail;
extern double				brightness;

extern TRIANGLEINFO			*abombman_body;
extern TRIANGLEINFO			*floor_tile[8];
extern TRIANGLEINFO			*trampoline[4];
extern TRIANGLEINFO			*food;
extern TRIANGLEINFO			*bridge[2];
extern TRIANGLEINFO			*shadow;
extern TRIANGLEINFO			*ghost;
extern TRIANGLEINFO			*dots[3];
extern TRIANGLEINFO			*numbers[10];

TRIANGLEINFO *add_triangle(TRIANGLEINFO *trianglelist, double x[3], double y[3], double z[3], double scalefac);
void free_trianglelist(TRIANGLEINFO *trianglelist);
void trianglelist_to_vertex(TRIANGLEINFO *trianglelist);
void create_trianglelists(void);
void destroy_trianglelists(void);
TRIANGLEINFO *set_trianglecolor(TRIANGLEINFO *trianglelist, float red, float green, float blue, float alpha);

TRIANGLEINFO *create_abombman_body(double scalefac);
TRIANGLEINFO *create_floor_tile(double scalefac, double brightness, double depth);
TRIANGLEINFO *create_trampoline(double scalefac, double depth, double color1[3], double color2[3]);
TRIANGLEINFO *create_food(double scalefac);
TRIANGLEINFO *create_bridge(double scalefac);
TRIANGLEINFO *create_shadow(double scalefac);
TRIANGLEINFO *create_dot(double scalefac, double color[3]);
TRIANGLEINFO *create_numbers(double scalefac, char *number);

void create_trianglelists(void);
void destroy_trianglelists(void);

#endif
