#include <math.h>
#include <allegro.h>
#include "utils.h"

void normalize(double v[3]);
void normcrossprod(double v1[3], double v2[3], double out[3]);

void normalize(double v[3])
{
	double d = sqrt(v[0]*v[0]+v[1]*v[1]+v[2]*v[2]);
	if (d!=0.0)
	{
		v[0]/=d; v[1]/=d; v[2]/=d;
	}
}

void normcrossprod(double v1[3], double v2[3], double out[3])
{
	out[0] = v2[1]*v2[2] - v1[2]*v2[1];
	out[1] = v1[2]*v2[0] - v1[0]*v2[2];
	out[2] = v1[0]*v2[1] - v1[0]*v2[0];
	normalize(out);
}

